'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _jsJoda = require('js-joda');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ResponseHandler = function () {
    function ResponseHandler(model, json) {
        (0, _classCallCheck3.default)(this, ResponseHandler);

        this.model = model;
        this.json = json;
    }

    (0, _createClass3.default)(ResponseHandler, [{
        key: 'handle',
        value: function handle() {
            if (_lodash2.default.isEmpty(this.json)) {
                return null;
            }

            if (_lodash2.default.isArray(this.json)) {
                return this.deserializeArray(this.json, this.model);
            }

            return this.deserializeOne(this.json, this.model);
        }
    }, {
        key: 'deserializeOne',
        value: function deserializeOne(json, model) {
            var instance = this.newInstanceOf(model);
            var dates = instance.getDates();
            var dateNames = Object.keys(dates);
            var fields = instance.getFields();
            var relations = instance.getRelations();
            var relationNames = Object.keys(relations);

            for (var prop in json) {
                if (dateNames.includes(prop)) {
                    instance[prop] = this.dateFromString(dates[prop], json[prop]);
                } else if (fields.includes(prop)) {
                    instance[prop] = json[prop];
                } else if (relationNames.includes(prop)) {
                    if (relations[prop].list) {
                        instance[prop] = this.deserializeArray(json[prop], relations[prop].instance);
                    } else {
                        instance[prop] = this.deserializeOne(json[prop], relations[prop].instance);
                    }
                }
            }

            return instance;
        }
    }, {
        key: 'deserializeArray',
        value: function deserializeArray(jsonArray, model) {
            var _this = this;

            return jsonArray.map(function (json) {
                return _this.deserializeOne(json, model);
            });
        }
    }, {
        key: 'newInstanceOf',
        value: function newInstanceOf(obj) {
            // const clone = Object.assign({}, obj);
            // Object.setPrototypeOf(clone, obj.prototype);
            // return clone;

            return _lodash2.default.clone(obj);
        }
    }, {
        key: 'dateFromString',
        value: function dateFromString(dateType, dateString) {

            if (dateType === 'datetime') {
                dateString = dateString.replace('T', ' ');
                dateString = dateString.replace('Z', '');

                var _dateString$split = dateString.split(' '),
                    _dateString$split2 = (0, _slicedToArray3.default)(_dateString$split, 2),
                    dateStr = _dateString$split2[0],
                    timeStr = _dateString$split2[1];

                var _dateStr$split$map = dateStr.split('-').map(Number),
                    _dateStr$split$map2 = (0, _slicedToArray3.default)(_dateStr$split$map, 3),
                    y = _dateStr$split$map2[0],
                    m = _dateStr$split$map2[1],
                    d = _dateStr$split$map2[2];

                var _timeStr$split$map = timeStr.split(':').map(Number),
                    _timeStr$split$map2 = (0, _slicedToArray3.default)(_timeStr$split$map, 3),
                    h = _timeStr$split$map2[0],
                    i = _timeStr$split$map2[1],
                    s = _timeStr$split$map2[2];

                return _jsJoda.LocalDateTime.of(y, m, d, h, i, s);
            } else if (dateType === 'time') {
                var _dateString$split$map = dateString.split(':').map(Number),
                    _dateString$split$map2 = (0, _slicedToArray3.default)(_dateString$split$map, 3),
                    _h = _dateString$split$map2[0],
                    _i = _dateString$split$map2[1],
                    _s = _dateString$split$map2[2];

                return _jsJoda.LocalTime.of(_h, _i, _s);
            } else if (dateType === 'date') {
                var _dateString$split$map3 = dateString.split('-').map(Number),
                    _dateString$split$map4 = (0, _slicedToArray3.default)(_dateString$split$map3, 3),
                    _y = _dateString$split$map4[0],
                    _m = _dateString$split$map4[1],
                    _d = _dateString$split$map4[2];

                return _jsJoda.LocalDate.of(_y, _m, _d);
            }

            return null;
        }
    }], [{
        key: 'ofJson',
        value: function ofJson(model, json) {
            var handler = new ResponseHandler(model, json);
            return handler.handle();
        }
    }]);
    return ResponseHandler;
}();

exports.default = ResponseHandler;